﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Reflection;
using HP.FOT.Shared.LoggingSupport;
using Eds.AirSoa.Util.Messaging;

namespace RefactorMessages
{
    public class Util
    {
        public static string Serialize2XML(object obj)
        {
            if (obj == null) return null;

            if (obj.GetType() == typeof(string))
            {
                return (string)obj;
            }

            return Serializer.SerializeObject2XML(obj);
        }

        public static void WriteFile(string path, string str)
        {
            if (File.Exists(path))
            {
                File.Delete(path);
            }
            File.WriteAllText(path, str);
        }

        public static List<T> GetInstances<T>()
        {
            return (from t in Assembly.GetExecutingAssembly().GetTypes()
                    where t.GetInterfaces().Contains(typeof(T)) && t.GetConstructor(Type.EmptyTypes) != null
                    select (T)Activator.CreateInstance(t)).ToList();
        }

        public static void OO()
        {
            MemberInfo[] methodBase = typeof(AMMessageKeys.ApplicationErrorMessages).GetMembers();

            //var instructions = MethodBodyReader.GetInstructions(methodBase);

            //foreach (Instruction instruction in instructions)
            //{
            //    MethodInfo methodInfo = instruction.Operand as MethodInfo;

            //    if (methodInfo != null)
            //    {
            //        Type type = methodInfo.DeclaringType;
            //        ParameterInfo[] parameters = methodInfo.GetParameters();

            //        Console.WriteLine("{0}.{1}({2});",
            //            type.FullName,
            //            methodInfo.Name,
            //            String.Join(", ", parameters.Select(p => p.ParameterType.FullName + " " + p.Name).ToArray())
            //        );
            //    }
            //}
        }
    }
}
