﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HP.FOT.Shared.LoggingSupport;
using System.Reflection;
using Eds.AirSoa.Util.Messaging;
using System.IO;
using System.Xml.Linq;
using System.Data.OleDb;
using System.Data;
using Microsoft.CSharp;
using System.CodeDom.Compiler;
using System.CodeDom;

namespace RefactorMessages
{
    class Program
    {
        static void Main(string[] args)
        {
            /*
             cmd:
             c:>RefactorMessages.exe 2 ACM "C:\\" "c:" "C:\\Messages.xlsx" 
             c:>RefactorMessages.exe 0 AM "C:\\" "c:" "C:\\essages.xlsx" 
             * */
            // 0: write 1: read 2: both
            string mode;
            string tower;
            string loggingSupportFolder;
            string analysisResultFolder;
            string excelPath;

            if (args == null || args.Length <= 0)
            {
                mode = "2";
                loggingSupportFolder = @"C:\LoggingSupport\";
                analysisResultFolder = "c:";
                excelPath = @"C:\Messages.xlsx";
                tower = "ACM";
            }
            else
            {
                mode = args[0];
                tower = args[1];
                loggingSupportFolder = args[2];
                analysisResultFolder = args[3];
                excelPath = args[4];
            }

            var helper = new AnalyzeMessageXmlHelper(analysisResultFolder, loggingSupportFolder, tower);
            if (mode == "0" || mode == "2")
            {
                helper.GenerateCsvFromMessageResourceXml(true);
            }
            if (mode == "1" || mode == "2")
            {
                helper.GenerateXmlFromExcel(excelPath);
            }
        }
    }
}